<?php
/**
 *
 * ThinkUp/tests/TestOfPostErrorMySQLDAO.php
 *
 * Copyright (c) 2009-2010 Gina Trapani
 *
 * LICENSE:
 *
 * This file is part of ThinkUp (http://thinkupapp.com).
 *
 * ThinkUp is free software: you can redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 2 of the License, or (at your option) any
 * later version.
 *
 * ThinkUp is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with ThinkUp.  If not, see
 * <http://www.gnu.org/licenses/>.
 */
require_once dirname(__FILE__).'/init.tests.php';
require_once THINKUP_ROOT_PATH.'webapp/_lib/extlib/simpletest/autorun.php';
require_once THINKUP_ROOT_PATH.'webapp/config.inc.php';

/**
 * Test PostErrorMySQLDAO
 *
 * @license http://www.gnu.org/licenses/gpl.html
 * @copyright 2009-2010 Gina Trapani
 * @author Gina Trapani <ginatrapani[at]gmail[dot]com>
 *
 */
class TestOfPostErrorMySQLDAO extends ThinkUpUnitTestCase {

    public function _construct() {
        $this->UnitTestCase('PostErrorMySQLDAO class test');
    }

    public function setUp() {
        parent::setUp();
    }

    public function tearDown() {
        parent::tearDown();
    }

    /**
     * Test constructor
     */
    public function testConstructor(){
        $dao = new PostErrorMySQLDAO();
        $this->assertTrue(isset($dao));

    }

    /**
     * Test error insertion
     */
    public function testInsert() {
        $dao = new PostErrorMySQLDAO();
        $result = $dao->insertError(10, 'twitter', 404, 'Status not found', 930061);
        $this->assertEqual($result, 1);

        $result = $dao->insertError(11, 'twitter', 403, 'You are not autorized to see this status', 930061);
        $this->assertEqual($result, 2);
    }
}